open Ast

(* (1 + 2) + (3 + (X + 5)) *)
let e = Plus(Plus(Cint 1l, Cint 2l), Plus(Cint 3l, Plus(Arg, Cint 5l)))

(* X86 compilation *)
let cu = Compiler.compile_exp e 
;; Cunit.output_cunit cu stdout



(* SLL translation 1 *)
let sll = Sll.sll_exp e
let sllstr = Sll.cmd_to_string sll 
;; Printf.printf "-------------\nSLL:\n%s\n" sllstr

(* Interpretation via CPS *)
let ans = Sll.interp 330l e 
;; Printf.printf "-------------\nInterpreter CPS:\n%d\n" (Int32.to_int ans)



(* SLL translation 2 - CPS *)
let sll2 = Sll.sll_exp_cps e
let sllstr = Sll.cmd_to_string sll 
;; Printf.printf "-------------\nSLL CPS:\n%s\n" sllstr


